function s3_TaskDownloadSync(_1,_2,_3,_4,_5){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","DownloadSyncComplete","DownloadSyncFailed","PrepareDownloadSyncFailed","PrepareDownloadSyncComplete"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
this.mainRemotePath=_3;
this.hasErrors=false;
this.mainLocalPath=_4;
this.skipUnchanged=_5;
this.hashFiles=null;
}
s3_TaskDownloadSync.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},init:function(){
this.prepareForDownloadSync();
},addToQueue:function(_6,_7){
var _8=_7||{processed:false,isExists:false,existHeaders:null,hasHeaders:false};
if(_6.isDirectory){
_8["type"]="folder";
}else{
_8["type"]="file";
}
var _9=new s3_QItem(_6,this.authInfo,1,_8);
this.processItems.push(_9);
},startProcessing:function(){
this.addTask("Preparing for GET...","");
this.indexDirty=true;
this.init();
},prepareForDownloadSync:function(){
var _a=this.mainRemotePath;
var _b=this.getActionInstance(this.authInfo,function(){
if(_b.hasErrors){
s3_logView.log(_b.errorMessage,"CustomError");
this.eventManager.fireEvent("PrepareDownloadSyncFailed",[this,"Preparing Download failed"]);
this.setTaskError();
return;
}
var _c={};
for(var k=0;k<_b.arrFiles.length;k++){
var _e=_b.arrFiles[k].filePath;
var _f="/"+_e.replace(this.mainRemotePath,"");
_c[_f]=_b.arrFiles[k];
var _10={isExists:false,processed:false,existHeaders:null,hasHeaders:false};
this.addToQueue(_b.arrFiles[k],_10);
}
this.hashFiles=_c;
this.removeLocalFiles(this.mainLocalPath);
this.indexDirty=true;
var _11=this;
setTimeout(function(){
_11.processNextItem();
},100);
});
_b.listAllFiles(_a,true,null);
this.actionInstance=_b;
this.updateTask("Retrieving remote file information...");
s3_logView.log("Retrieving remote file information...","message");
},processNextItem:function(){
var _12=this.getNextIndex();
if(_12>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("PrepareDownloadSyncFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("PrepareDownloadSyncComplete",[this]);
if(this.updateView){
this.addToSyncQ();
}
s3_dump("Download processItem = ");
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_12];
try{
this.prepareForDownload(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("PrepareDownloadSyncFailed",[this,ex]);
}
},prepareForDownload:function(_13){
var _14=this;
if(!_13.properties["processed"]){
_13.status=s3_progStatus.PROGRESS;
var act=this.getActionInstance(_13.authInfo,function(_16,_17){
_13.properties["processed"]=true;
_13.status=s3_progStatus.PREDOWNLOAD;
if(_16){
_13.properties["existHeaders"]=_17;
_13.properties["hasHeaders"]=true;
var _18=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
var _19=_13.key.filePath.replace(this.mainRemotePath,"");
var _1a=s3_Utils.localPath(this.mainLocalPath+"\\"+_19);
_18.initWithPath(_1a);
_13.properties["localPath"]=s3_Utils.localPath(_1a);
if(_18.exists()){
_13.properties["localModifiedTime"]=_18.lastModifiedTime;
_13.properties["localFileSize"]=_18.fileSize;
_13.properties["isExists"]=true;
}else{
_13.properties["isExists"]=false;
}
s3_dump("downloadsync remotePath "+_18.path+", sss = "+_18.exists()+", "+_13.key.filePath);
}else{
_13.properties["isExists"]=false;
}
setTimeout(function(){
_14.processNextItem();
},1);
});
var _1b=_13.key.filePath;
if(_13.key.isDirectory){
_1b+="_$folder$";
}
act.getHeaderInfo(_1b);
_13.actionInstance=act;
}else{
_13.status=s3_progStatus.PREDOWNLOAD;
setTimeout(function(){
_14.processNextItem();
},1);
}
this.updateTask("Loading "+_13.key.fileName);
s3_logView.log("Loading to Download - "+_13.key.fileName,"message");
},removeLocalFiles:function(_1c){
var dir=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
dir.initWithPath(_1c);
if(!dir.exists()||!dir.isDirectory()){
return;
}
var _1e;
var _1f=dir.directoryEntries;
while(_1f.hasMoreElements()){
_1e=false;
var _20=_1f.getNext().QueryInterface(Components.interfaces.nsILocalFile);
var _21=_20.path.replace(this.mainLocalPath,"");
_21=_21.replace(/\\/gi,"/");
if(this.hashFiles[_21]!=null){
s3_dump("exists "+_21);
_1e=true;
}else{
_20.remove(true);
continue;
}
if(_20.isDirectory()){
this.removeLocalFiles(_20.path);
}
_20=null;
}
},addToSyncQ:function(){
var _22=-s3_syncActionsTreeView.getRowCount();
for(var m=0;m<this.processItems.length;m++){
var _24=this.processItems[m];
var _25=null;
s3_dump("Downloadsync header "+_24.properties["isExists"]+", "+_24.key.filePath);
if(_24.properties["isExists"]){
var _26=_24.properties["existHeaders"];
s3_dump("Downloadsync header "+_24.properties["localModifiedTime"]+", "+_26["x-amz-meta-s3fox-modifiedtime"]);
if(this.skipUnchanged&&_26["x-amz-meta-s3fox-modifiedtime"]==_24.properties["localModifiedTime"]&&_26["x-amz-meta-s3fox-filesize"]==_24.properties["localFileSize"]){
continue;
}
_25={};
}
s3_dump("before adding - "+_24.key.filePath);
var _27=new s3_ActionRow(_24.key.filePath,s3_Utils.localPath(_24.properties["localPath"]),_24.key.fileName,s3_progStatus.INIT,"download",_24.key.fileSize,"",_24.key.isDirectory,_25,_24.authInfo,(new Date()).getTime()+""+m);
s3_syncActionsTreeView.arrActionQ.push(_27);
}
if(s3_syncActionsTreeView.treeBox){
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_22);
_22=s3_syncActionsTreeView.getRowCount();
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_22);
}
s3_syncActionsTreeView.ProcessActionQ("download");
}};
s3_extend(s3_TaskDownloadSync,s3_Task);

