function s3_TaskUpload(_1,_2,_3){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","UploadComplete","UploadFailed","PrepareUploadFailed","PrepareUploadComplete"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
this.mainRemotePath=_3;
this.hasErrors=false;
this.mainLocalPath;
this.hashFiles=null;
}
s3_TaskUpload.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},addToQueue:function(_4,_5){
var _6=_5||{checkedOnServer:false,isExists:false,existHeaders:null,hasHeaders:false};
if(_4.isDirectory){
_6["type"]="folder";
}else{
_6["type"]="file";
}
var _7=new s3_QItem(_4,this.authInfo,1,_6);
this.processItems.push(_7);
},startProcessing:function(){
this.indexDirty=true;
this.processNextItem();
this.addTask("Preparing for Upload...","");
},processNextItem:function(){
var _8=this.getNextIndex();
if(_8>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("PrepareUploadFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("PrepareUploadComplete",[this]);
if(this.updateView){
this.getInputFromUser();
}
s3_dump("upload processItem = ");
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_8];
try{
this.prepareForUpload(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("PrepareUploadFailed",[this,ex]);
}
},prepareForUpload:function(_9){
var _a=this;
if(_9.properties["type"]!="file"){
if(!_9.properties["checkedOnServer"]){
var _b=this.mainRemotePath+_9.key.fileName;
var _c=this.getActionInstance(_9.authInfo,function(){
if(_c.hasErrors){
s3_logView.log(_c.errorMessage,"CustomError");
this.eventManager.fireEvent("PrepareUploadFailed",[this,"Preparing Upload failed"]);
this.setTaskError();
return;
}
var _d={};
for(var k=0;k<_c.arrFiles.length;k++){
var _f=_c.arrFiles[k].filePath;
var _10="/"+_f.replace(this.mainRemotePath,"");
_d[_10]=_c.arrFiles[k];
}
this.mainLocalPath=_9.key.parentPath;
this.hashFiles=_d;
var _11=_9.key.filePath.replace(this.mainLocalPath,"");
_11=_11.replace(/\\/gi,"/");
if(this.hashFiles[_11]!=null){
s3_dump("exists "+_11);
_9.properties["isExists"]=true;
}
_9.properties["remotePath"]=this.mainRemotePath;
_9.properties["checkedOnServer"]=true;
this.checkSubFolders(_9.key.filePath);
this.indexDirty=true;
this.processNextItem();
});
if(this.mainRemotePath=="/"){
_b+="/";
}
_9.status=s3_progStatus.PROGRESS;
_c.listAllFiles(_b,true,null);
_9.actionInstance=_c;
this.updateTask("Retrieving remote file information...");
s3_logView.log("Retrieving remote file information...","message");
return;
}else{
_9.status=s3_progStatus.PREUPLOAD;
setTimeout(function(){
_a.processNextItem();
},1);
}
}else{
if(!_9.properties["checkedOnServer"]){
_9.status=s3_progStatus.PROGRESS;
var _c=this.getActionInstance(_9.authInfo,function(_12,_13){
_9.properties["checkedOnServer"]=true;
_9.status=s3_progStatus.PREUPLOAD;
if(_12){
_9.properties["existHeaders"]=_13;
_9.properties["hasHeaders"]=true;
_9.properties["isExists"]=true;
}else{
_9.properties["isExists"]=false;
}
setTimeout(function(){
_a.processNextItem();
},1);
});
_c.getHeaderInfo(this.mainRemotePath+_9.key.fileName);
_9.actionInstance=_c;
_9.properties["remotePath"]=this.mainRemotePath;
}else{
_9.status=s3_progStatus.PREUPLOAD;
setTimeout(function(){
_a.processNextItem();
},1);
}
}
this.updateTask("Loading "+_9.key.fileName);
s3_logView.log("Loading to upload - "+_9.key.fileName,"message");
},checkSubFolders:function(_14){
var dir=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
dir.initWithPath(_14);
if(!dir.exists()||!dir.isDirectory()){
return;
}
var _16;
var _17=dir.directoryEntries;
while(_17.hasMoreElements()){
_16=false;
var _18=_17.getNext().QueryInterface(Components.interfaces.nsILocalFile);
var _19=new s3_localFileInfo(_18.path,_18.leafName,_18.parent.path,_18.fileSize,_18.lastModifiedTime,_18.isDirectory());
var _1a=_18.path.replace(this.mainLocalPath,"");
_1a=_1a.replace(/\\/gi,"/");
if(this.hashFiles[_1a]!=null){
s3_dump("exists "+_1a);
_16=true;
}
var _1b={checkedOnServer:true,isExists:_16,existHeaders:null,hasHeaders:false};
var _1c=this.mainRemotePath+_1a.substr(1);
_1c=_1c.substr(0,_1c.lastIndexOf("/")+1);
_1b["remotePath"]=_1c;
s3_dump("task upload; Remote Path = "+this.mainRemotePath+_1a.substr(1)+", "+_1b["remotePath"]);
this.addToQueue(_19,_1b);
if(_19.isDirectory){
this.checkSubFolders(_19.filePath);
}
}
},getInputFromUser:function(){
var _1d=-s3_actionTreeView.getRowCount();
s3_fileOpPref.askOption=true;
for(var m=0;m<this.processItems.length;m++){
var _1f=this.processItems[m];
var _20=null;
if(_1f.properties["isExists"]){
if(s3_fileOpPref.askOption){
window.openDialog("chrome://s3fox/content/s3Overwrite.xul","Overwrite Options","chrome,modal,centerscreen",s3_fileOpPref,_1f.key.fileName,"regular");
}
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.SKIP){
s3_fileOpPref.askOption=true;
continue;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.SKIP_ALL||s3_fileOpPref.overwriteOption==s3_fileOpPref.CANCEL){
s3_fileOpPref.askOption=false;
continue;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.OVERWRITE_DELETE){
s3_fileOpPref.askOption=true;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.OVERWRITE_DELETE_ALL){
s3_fileOpPref.askOption=false;
}
}
}
}
_20={};
}
this.updateTask("Adding to Q "+_1f.key.fileName);
s3_logView.log("Adding to Q - "+_1f.key.fileName,"message");
s3_dump("before adding - "+_1f.properties["remotePath"]);
var _21=new s3_ActionRow(s3_Utils.localPath(_1f.key.parentPath),_1f.properties["remotePath"],_1f.key.fileName,s3_progStatus.INIT,"upload",_1f.key.fileSize,"",_1f.key.isDirectory,_20,_1f.authInfo,(new Date()).getTime()+""+m);
s3_actionTreeView.arrActionQ.push(_21);
}
if(s3_actionTreeView.treeBox){
s3_actionTreeView.treeBox.rowCountChanged(0,_1d);
_1d=s3_actionTreeView.getRowCount();
s3_actionTreeView.treeBox.rowCountChanged(0,_1d);
}
s3_actionTreeView.ProcessActionQ("upload");
}};
s3_extend(s3_TaskUpload,s3_Task);

