function s3_TaskUploadSync(_1,_2,_3,_4,_5){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","UploadSyncComplete","UploadSyncFailed","PrepareUploadSyncFailed","PrepareUploadSyncComplete"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
this.mainRemotePath=_3;
this.hasErrors=false;
this.mainLocalPath=_4;
this.skipUnchanged=_5;
this.hashFiles=null;
}
s3_TaskUploadSync.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},init:function(){
var _6=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
_6.initWithPath(this.mainLocalPath);
if(!_6.exists()||!_6.isDirectory()){
this.setTaskError();
this.eventManager.fireEvent("PrepareUploadSyncFailed",[this,"Invalid local directory"]);
return;
}else{
this.prepareForUploadSync();
}
},addToQueue:function(_7,_8){
var _9=_8||{checkedOnServer:false,isExists:false,existHeaders:null,hasHeaders:false};
if(_7.isDirectory){
_9["type"]="folder";
}else{
_9["type"]="file";
}
var _a=new s3_QItem(_7,this.authInfo,1,_9);
this.processItems.push(_a);
},startProcessing:function(){
this.indexDirty=true;
this.init();
this.addTask("Preparing for PUT...","");
},prepareForUploadSync:function(){
var _b=this.mainRemotePath;
var _c=this.getActionInstance(this.authInfo,function(){
if(_c.hasErrors){
s3_logView.log(_c.errorMessage,"CustomError");
this.eventManager.fireEvent("PrepareUploadSyncFailed",[this,"Preparing Upload failed"]);
this.setTaskError();
return;
}
var _d={};
for(var k=0;k<_c.arrFiles.length;k++){
var _f=_c.arrFiles[k].filePath;
var _10="/"+_f.replace(this.mainRemotePath,"");
_d[_10]=_c.arrFiles[k];
}
this.hashFiles=_d;
this.checkSubFolders(this.mainLocalPath);
this.indexDirty=true;
this.processNextItem();
});
_c.listAllFiles(_b,true,null);
this.actionInstance=_c;
this.updateTask("Retrieving remote file information...");
s3_logView.log("Retrieving remote file information...","message");
},processNextItem:function(){
var _11=this.getNextIndex();
if(_11>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("PrepareUploadSyncFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("PrepareUploadSyncComplete",[this]);
if(this.updateView){
this.deleteExtraRemoteFiles(this.hashFiles);
this.addToSyncQ();
}
s3_dump("upload processItem = ");
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_11];
try{
this.prepareForUpload(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("PrepareUploadSyncFailed",[this,ex]);
}
},prepareForUpload:function(_12){
var _13=this;
if(!_12.properties["checkedOnServer"]){
_12.status=s3_progStatus.PROGRESS;
var act=this.getActionInstance(_12.authInfo,function(_15,_16){
_12.properties["checkedOnServer"]=true;
_12.status=s3_progStatus.PREUPLOAD;
if(_15){
_12.properties["existHeaders"]=_16;
_12.properties["hasHeaders"]=true;
_12.properties["isExists"]=true;
}else{
_12.properties["isExists"]=false;
}
setTimeout(function(){
_13.processNextItem();
},1);
});
var _17=_12.key.fileName;
if(_12.key.isDirectory){
_17+="_$folder$";
}
act.getHeaderInfo(_12.properties["remotePath"]+_17);
_12.actionInstance=act;
}else{
_12.status=s3_progStatus.PREUPLOAD;
setTimeout(function(){
_13.processNextItem();
},1);
}
this.updateTask("Loading "+_12.key.fileName);
s3_logView.log("Loading to upload - "+_12.key.fileName,"message");
},checkSubFolders:function(_18){
var dir=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
dir.initWithPath(_18);
if(!dir.exists()||!dir.isDirectory()){
return;
}
var _1a;
var _1b=dir.directoryEntries;
while(_1b.hasMoreElements()){
_1a=false;
var _1c=_1b.getNext().QueryInterface(Components.interfaces.nsILocalFile);
var _1d=new s3_localFileInfo(_1c.path,_1c.leafName,_1c.parent.path,_1c.fileSize,_1c.lastModifiedTime,_1c.isDirectory());
var _1e=_1c.path.replace(this.mainLocalPath,"");
_1e=_1e.replace(/\\/gi,"/");
if(this.hashFiles[_1e]!=null){
s3_dump("exists "+_1e);
this.hashFiles[_1e].properties={found:true};
_1a=true;
}
var _1f={checkedOnServer:!_1a,isExists:_1a,existHeaders:null,hasHeaders:false};
var _20=this.mainRemotePath+_1e.substr(1);
_20=_20.substr(0,_20.lastIndexOf("/")+1);
_1f["remotePath"]=_20;
this.addToQueue(_1d,_1f);
if(_1d.isDirectory){
this.checkSubFolders(_1d.filePath);
}
}
},deleteExtraRemoteFiles:function(_21){
var _22=null;
for(var _23 in _21){
if(_21[_23].properties==null){
if(_22==null){
_22=new s3_TaskDelete(false,s3_uiManager.authInfo);
}
_22.addToDelete(_21[_23],{filesFetched:false});
}
}
if(_22){
_22.startProcessing();
}
},addToSyncQ:function(){
var _24=-s3_syncActionsTreeView.getRowCount();
for(var m=0;m<this.processItems.length;m++){
var _26=this.processItems[m];
var _27=null;
s3_dump("uploadsync header "+_26.properties["remotePath"]+_26.key.fileName+", "+",  "+_26.properties["isExists"]);
if(_26.properties["isExists"]){
var _28=_26.properties["existHeaders"];
if(this.skipUnchanged&&_28["x-amz-meta-s3fox-modifiedtime"]==_26.key.modifiedTime&&_28["x-amz-meta-s3fox-filesize"]==_26.key.fileSize){
continue;
}
_27={};
}
var _29=new s3_ActionRow(s3_Utils.localPath(_26.key.parentPath),_26.properties["remotePath"],_26.key.fileName,s3_progStatus.INIT,"upload",_26.key.fileSize,"",_26.key.isDirectory,_27,_26.authInfo,(new Date()).getTime()+""+m);
s3_syncActionsTreeView.arrActionQ.push(_29);
}
if(s3_syncActionsTreeView.treeBox){
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_24);
_24=s3_syncActionsTreeView.getRowCount();
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_24);
}
s3_syncActionsTreeView.ProcessActionQ("upload");
}};
s3_extend(s3_TaskUploadSync,s3_Task);

